#ifndef DELAY_H
#define DELAY_H
/*-------------------------------------------------------------*/
/*				Includes and dependencies						*/
/*-------------------------------------------------------------*/
#include "DelayPort.h"
/*-------------------------------------------------------------*/
/*				Macros and definitions							*/
/*-------------------------------------------------------------*/

/*-------------------------------------------------------------*/
/*				Typedefs enums & structs						*/
/*-------------------------------------------------------------*/

/*-------------------------------------------------------------*/
/*				Function prototypes								*/
/*-------------------------------------------------------------*/
#ifndef vDelayMilis
/**
Blocks the program operation for a given interval of time expressed in mili
seconds

@param ulMiliseconds The ammount of time to block program execution.
*/
void vDelayMilis(unsigned long ulMiliseconds);
#endif

#ifndef vDelayMicros
/**
Blocks the program operation for a given interval of time expressed in micro
seconds

@param ulMicroseconds The ammount of time to block program execution.
*/
void vDelayMicros(unsigned long ulMicroseconds);
#endif

#ifndef vDelayCycles
/**
Blocks the program operation for a given interval of time expressed in
instruction cycles

@param ulCpuCycles The number of CPU cycles to block program execution
*/
void vDelayCycles(unsigned long ulCpuCycles);
#endif

#endif
// End of Header file
