#include "EEPROM.h"
#include "xc.h"


void vEEPROMWrite( BYTE xData, WORD xAddress )
{
	di();
	EEADR = xAddress;
	EEDATA = xData;	// Set the data to write.
	WREN=1;			// Enable writes.
	EECON2=0x00;	// Get on the right bank
	#asm
	MOVLW	0x55
	MOVWF	EECON2
	MOVLW	0xaa
	MOVWF	EECON2
	BSF	EECON1,1
	#endasm
	while(EECON1bits.WR);
	WREN=0;		// Disable writes.
	ei();
}

BYTE xEEPROMRead( WORD xAddress )
{
	EEADR = xAddress;
	EECON1bits.RD = 1;
	return EEDATA;
}

void vEEPROMWriteBlock( WORD xDestAddr, void * pvWriteBuffer, WORD xWriteCount )
{
	WORD xTemp = 0;
	while( xWriteCount )
	{
		vEEPROMWrite( ((BYTE *)pvWriteBuffer)[xTemp++], xDestAddr++ );
		xWriteCount --;
	}
}

void vEEPROMReadBlock( WORD xSrcAddr, void * pvReadBuffer, WORD xReadCount )
{
	while( xReadCount )
	{
		*((BYTE *)pvReadBuffer) = xEEPROMRead( xSrcAddr );
		xReadCount--;
	}
}