#include "Tick.h"

static void prvReadTick();
/* Internal counter for timer interrupts */
static volatile unsigned long xTickCounter = 0;
/* Total counter 6 bytes including timer register value */
static unsigned char xTickReading[6];

void vTickInitialize()
{
	T1CON = 0;
	TMR1L = 0;
	TMR1H = 0;
	// Internal clock, 1:8 prescaler, timer enabled
	PIR1bits.TMR1IF = 0;
	PIE1bits.TMR1IE = 1;
	// Enable global interrupts and peripheral interrupts
	INTCONbits.GIE = 1;
	INTCONbits.PEIE = 1;
	// Internal clock, 1:8 prescaler, timer enabled
	//T1CON = 0x01;
	T1CON = 0x31;
}

unsigned long xTickGet()
{
	prvReadTick();
	return *((DWORD *)&xTickReading[0]);
}

static void prvReadTick()
{	
	do
	{
		PIE1bits.TMR1IE = 1;		// Enable interrupt
		asm("nop");
		PIE1bits.TMR1IE = 0;		// Disable interrupt
		
		xTickReading[0] = TMR1L;
		xTickReading[1] = TMR1H;
		
		*((DWORD*) &xTickReading[2] ) = xTickCounter;
	} while( PIR1bits.TMR1IF );
	PIE1bits.TMR1IE = 1;
}

void vTickUpdater()
{
	if( PIR1bits.TMR1IF )
	{
		xTickCounter ++;
		PIR1bits.TMR1IF = 0;
	}
}